<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerEmail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomerEmail
 * @subpackage Arrays
 */
class ArrayOfCustomerEmail extends AbstractStructArrayBase
{
    /**
     * The CustomerEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CustomerEmail[]
     */
    public $CustomerEmail;
    /**
     * Constructor method for ArrayOfCustomerEmail
     * @uses ArrayOfCustomerEmail::setCustomerEmail()
     * @param \App|C\StructType\CustomerEmail[] $customerEmail
     */
    public function __construct(array $customerEmail = array())
    {
        $this
            ->setCustomerEmail($customerEmail);
    }
    /**
     * Get CustomerEmail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CustomerEmail[]|null
     */
    public function getCustomerEmail()
    {
        return isset($this->CustomerEmail) ? $this->CustomerEmail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerEmail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerEmail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerEmailForArrayConstraintsFromSetCustomerEmail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerEmailCustomerEmailItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerEmailCustomerEmailItem instanceof \App|C\StructType\CustomerEmail) {
                $invalidValues[] = is_object($arrayOfCustomerEmailCustomerEmailItem) ? get_class($arrayOfCustomerEmailCustomerEmailItem) : sprintf('%s(%s)', gettype($arrayOfCustomerEmailCustomerEmailItem), var_export($arrayOfCustomerEmailCustomerEmailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerEmail property can only contain items of type \App|C\StructType\CustomerEmail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerEmail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\CustomerEmail[] $customerEmail
     * @return \App|C\ArrayType\ArrayOfCustomerEmail
     */
    public function setCustomerEmail(array $customerEmail = array())
    {
        // validation for constraint: array
        if ('' !== ($customerEmailArrayErrorMessage = self::validateCustomerEmailForArrayConstraintsFromSetCustomerEmail($customerEmail))) {
            throw new \InvalidArgumentException($customerEmailArrayErrorMessage, __LINE__);
        }
        if (is_null($customerEmail) || (is_array($customerEmail) && empty($customerEmail))) {
            unset($this->CustomerEmail);
        } else {
            $this->CustomerEmail = $customerEmail;
        }
        return $this;
    }
    /**
     * Add item to CustomerEmail value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\CustomerEmail $item
     * @return \App|C\ArrayType\ArrayOfCustomerEmail
     */
    public function addToCustomerEmail(\App|C\StructType\CustomerEmail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\CustomerEmail) {
            throw new \InvalidArgumentException(sprintf('The CustomerEmail property can only contain items of type \App|C\StructType\CustomerEmail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerEmail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\CustomerEmail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\CustomerEmail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\CustomerEmail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\CustomerEmail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\CustomerEmail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerEmail
     */
    public function getAttributeName()
    {
        return 'CustomerEmail';
    }
}
