<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareConditionText ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareConditionText
 * @subpackage Arrays
 */
class ArrayOfFareConditionText extends AbstractStructArrayBase
{
    /**
     * The FareConditionText
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareConditionText[]
     */
    public $FareConditionText;
    /**
     * Constructor method for ArrayOfFareConditionText
     * @uses ArrayOfFareConditionText::setFareConditionText()
     * @param \App|C\StructType\FareConditionText[] $fareConditionText
     */
    public function __construct(array $fareConditionText = array())
    {
        $this
            ->setFareConditionText($fareConditionText);
    }
    /**
     * Get FareConditionText value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareConditionText[]|null
     */
    public function getFareConditionText()
    {
        return isset($this->FareConditionText) ? $this->FareConditionText : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareConditionText method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareConditionText method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareConditionTextForArrayConstraintsFromSetFareConditionText(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareConditionTextFareConditionTextItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareConditionTextFareConditionTextItem instanceof \App|C\StructType\FareConditionText) {
                $invalidValues[] = is_object($arrayOfFareConditionTextFareConditionTextItem) ? get_class($arrayOfFareConditionTextFareConditionTextItem) : sprintf('%s(%s)', gettype($arrayOfFareConditionTextFareConditionTextItem), var_export($arrayOfFareConditionTextFareConditionTextItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareConditionText property can only contain items of type \App|C\StructType\FareConditionText, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareConditionText value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FareConditionText[] $fareConditionText
     * @return \App|C\ArrayType\ArrayOfFareConditionText
     */
    public function setFareConditionText(array $fareConditionText = array())
    {
        // validation for constraint: array
        if ('' !== ($fareConditionTextArrayErrorMessage = self::validateFareConditionTextForArrayConstraintsFromSetFareConditionText($fareConditionText))) {
            throw new \InvalidArgumentException($fareConditionTextArrayErrorMessage, __LINE__);
        }
        if (is_null($fareConditionText) || (is_array($fareConditionText) && empty($fareConditionText))) {
            unset($this->FareConditionText);
        } else {
            $this->FareConditionText = $fareConditionText;
        }
        return $this;
    }
    /**
     * Add item to FareConditionText value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FareConditionText $item
     * @return \App|C\ArrayType\ArrayOfFareConditionText
     */
    public function addToFareConditionText(\App|C\StructType\FareConditionText $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FareConditionText) {
            throw new \InvalidArgumentException(sprintf('The FareConditionText property can only contain items of type \App|C\StructType\FareConditionText, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareConditionText[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FareConditionText|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FareConditionText|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FareConditionText|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FareConditionText|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FareConditionText|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareConditionText
     */
    public function getAttributeName()
    {
        return 'FareConditionText';
    }
}
