<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialService ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSpecialService
 * @subpackage Arrays
 */
class ArrayOfSpecialService extends AbstractStructArrayBase
{
    /**
     * The SpecialService
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SpecialService[]
     */
    public $SpecialService;
    /**
     * Constructor method for ArrayOfSpecialService
     * @uses ArrayOfSpecialService::setSpecialService()
     * @param \App|C\StructType\SpecialService[] $specialService
     */
    public function __construct(array $specialService = array())
    {
        $this
            ->setSpecialService($specialService);
    }
    /**
     * Get SpecialService value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SpecialService[]|null
     */
    public function getSpecialService()
    {
        return isset($this->SpecialService) ? $this->SpecialService : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSpecialService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSpecialService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSpecialServiceForArrayConstraintsFromSetSpecialService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSpecialServiceSpecialServiceItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialServiceSpecialServiceItem instanceof \App|C\StructType\SpecialService) {
                $invalidValues[] = is_object($arrayOfSpecialServiceSpecialServiceItem) ? get_class($arrayOfSpecialServiceSpecialServiceItem) : sprintf('%s(%s)', gettype($arrayOfSpecialServiceSpecialServiceItem), var_export($arrayOfSpecialServiceSpecialServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SpecialService property can only contain items of type \App|C\StructType\SpecialService, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SpecialService value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SpecialService[] $specialService
     * @return \App|C\ArrayType\ArrayOfSpecialService
     */
    public function setSpecialService(array $specialService = array())
    {
        // validation for constraint: array
        if ('' !== ($specialServiceArrayErrorMessage = self::validateSpecialServiceForArrayConstraintsFromSetSpecialService($specialService))) {
            throw new \InvalidArgumentException($specialServiceArrayErrorMessage, __LINE__);
        }
        if (is_null($specialService) || (is_array($specialService) && empty($specialService))) {
            unset($this->SpecialService);
        } else {
            $this->SpecialService = $specialService;
        }
        return $this;
    }
    /**
     * Add item to SpecialService value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SpecialService $item
     * @return \App|C\ArrayType\ArrayOfSpecialService
     */
    public function addToSpecialService(\App|C\StructType\SpecialService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SpecialService) {
            throw new \InvalidArgumentException(sprintf('The SpecialService property can only contain items of type \App|C\StructType\SpecialService, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SpecialService[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SpecialService|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SpecialService|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SpecialService|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SpecialService|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SpecialService|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpecialService
     */
    public function getAttributeName()
    {
        return 'SpecialService';
    }
}
