<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateBookingResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateBookingResponse
 * @subpackage Structs
 */
class CreateBookingResponse extends AbstractResponse
{
    /**
     * The CreateBookingResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CreateBookingResponse
     */
    public $CreateBookingResult;
    /**
     * The Booking
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * The InvalidData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\InvalidDataErrors
     */
    public $InvalidData;
    /**
     * Constructor method for CreateBookingResponse
     * @uses CreateBookingResponse::setCreateBookingResult()
     * @uses CreateBookingResponse::setBooking()
     * @uses CreateBookingResponse::setInvalidData()
     * @param \App|C\StructType\CreateBookingResponse $createBookingResult
     * @param \App|C\StructType\Booking $booking
     * @param \App|C\StructType\InvalidDataErrors $invalidData
     */
    public function __construct(\App|C\StructType\CreateBookingResponse $createBookingResult = null, \App|C\StructType\Booking $booking = null, \App|C\StructType\InvalidDataErrors $invalidData = null)
    {
        $this
            ->setCreateBookingResult($createBookingResult)
            ->setBooking($booking)
            ->setInvalidData($invalidData);
    }
    /**
     * Get CreateBookingResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CreateBookingResponse|null
     */
    public function getCreateBookingResult()
    {
        return isset($this->CreateBookingResult) ? $this->CreateBookingResult : null;
    }
    /**
     * Set CreateBookingResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\CreateBookingResponse $createBookingResult
     * @return \App|C\StructType\CreateBookingResponse
     */
    public function setCreateBookingResult(\App|C\StructType\CreateBookingResponse $createBookingResult = null)
    {
        if (is_null($createBookingResult) || (is_array($createBookingResult) && empty($createBookingResult))) {
            unset($this->CreateBookingResult);
        } else {
            $this->CreateBookingResult = $createBookingResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\CreateBookingResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
    /**
     * Get InvalidData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\InvalidDataErrors|null
     */
    public function getInvalidData()
    {
        return isset($this->InvalidData) ? $this->InvalidData : null;
    }
    /**
     * Set InvalidData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\InvalidDataErrors $invalidData
     * @return \App|C\StructType\CreateBookingResponse
     */
    public function setInvalidData(\App|C\StructType\InvalidDataErrors $invalidData = null)
    {
        if (is_null($invalidData) || (is_array($invalidData) && empty($invalidData))) {
            unset($this->InvalidData);
        } else {
            $this->InvalidData = $invalidData;
        }
        return $this;
    }
}
